part of charts;

/// <summary>
/// Specifies the Orientation of Axis
/// </summary>
enum AxisOrientation { vertical, horizontal }

/// <summary>
/// Specifies the range padding of Chart
/// </summary>
enum ChartRangePadding { auto, none, normal, additional, round }

/// <summary>
/// Specifies the label placement of axis label.
/// </summary>
enum LabelPlacement { betweenTicks, onTicks }

/// <summary>
/// Specifies the label intersection actions of axis label
/// </summary>
enum AxisLabelIntersectAction {
  none,
  hide,
  wrap,
  multipleRows,
  rotate45,
  rotate90
}

/// <summary>
/// Specifies the type of Datetime interval.
/// </summary>
enum DateTimeIntervalType { auto, years, months, days, hours, minutes, seconds }

/// <summary>
/// Specifies the tick position.
/// </summary>
enum LabelPosition { inside, outside }

/// <summary>
/// Specifies the Marker shapes
/// </summary>
enum DataMarkerType {
  circle,
  rectangle,
  image,
  pentagon,
  verticalLine,
  horizontalLine,
  diamond,
  triangle,
  invertedTriangle
}

/// <summary>
/// Specifies the type of spline.
/// </summary>
enum SplineType { natural, monotonic, cardinal, clamped }

/// <summary>
/// Specifies the data edge label position types.
/// </summary>
enum EdgeLabelPlacement { none, hide, shift }

/// <summary>
/// Specifies the Empty point setting modes.
/// </summary>
enum EmptyPointMode { gap, zero, drop, average }

/// <summary>
/// Specifies the Sorting based which order.
/// </summary>
enum SortingOrder { ascending, descending, none }

/// <summary>
/// Specifies the label position.
/// </summary>
enum TickPosition { inside, outside }

/// <summary>
/// Specifies the activation mode for tooltip.
/// </summary>
enum ActivationMode { singleTap, doubleTap, longPress, none }

/// <summary>
/// Specifies the display mode for cross hair.
/// </summary>
enum TrackballDisplayMode { none, floatAllPoints, groupAllPoints, nearestPoint }

/// <summary>
/// Specifies the type of line to dispaly for cross hair.
/// </summary>
enum CrosshairLineType { both, horizontal, vertical, none }

/// <summary>
/// Specifies the line type for cross hair.
/// </summary>
enum TrackballLineType { vertical, horizontal, none }

/// Specifies the zooming mode.
/// </summary>
enum ZoomMode { x, y, xy }

/// <summary>
/// Specifies the selection modes
/// </summary>
enum SelectionType { point, series, cluster }

/// <summary>
/// Specifies the annotation coordinate units
/// </summary>
enum CoordinateUnit { point, logicalPixel }

/// <summary>
/// Specifies the annotation region
/// </summary>
enum AnnotationRegion { chart, plotArea }

/// <summary>
/// Specifies the  border mode for Area series
/// </summary>

enum AreaBorderMode { all, top, excludeBottom }
