part of charts;

class SelectionSettings extends ChartSelectionBehavior {
  SelectionSettings(
      {bool enable,
        this. selectedColor,
        this. selectedBorderColor,
        this. selectedBorderWidth,
        this. unselectedColor,
        this. unselectedBorderColor,
        this. unselectedBorderWidth,
        double selectedOpacity,
        double unselectedOpacity})
      : enable = enable ?? false,
        selectedOpacity = selectedOpacity ?? 1.0,
        unselectedOpacity = unselectedOpacity ?? 0.5;

        

  ///```dart
  ///Widget build(BuildContext context) {
  ///    return Container(
  ///        child: SfCartesianChart(
  ///            series: <BarSeries<SalesData, num>>[
  ///                BarSeries<SalesData, num>(
  ///                  selectionSettings: SelectionSettings(
  ///                    enable: true
  ///                  ),
  ///                ),
  ///              ],
  ///        ));
  ///}
  ///```
  final bool enable;
  ///```dart
  ///Widget build(BuildContext context) {
  ///    return Container(
  ///        child: SfCartesianChart(
  ///            series: <BarSeries<SalesData, num>>[
  ///                BarSeries<SalesData, num>(
  ///                  selectionSettings: SelectionSettings(
  ///                    selectedColor: Colors.red.withOpacity(0.8)
  ///                  ),
  ///                ),
  ///              ],
  ///        ));
  ///}
  ///```
  final Color selectedColor;
  ///```dart
  ///Widget build(BuildContext context) {
  ///    return Container(
  ///        child: SfCartesianChart(
  ///            series: <BarSeries<SalesData, num>>[
  ///                BarSeries<SalesData, num>(
  ///                  selectionSettings: SelectionSettings(
  ///                    selectedBorderColor: Colors.red.withOpacity(0.8),
  ///                  ),
  ///                ),
  ///              ],
  ///        ));
  ///}
  ///```
  final Color selectedBorderColor;
  ///```dart
  ///Widget build(BuildContext context) {
  ///    return Container(
  ///        child: SfCartesianChart(
  ///            series: <BarSeries<SalesData, num>>[
  ///                BarSeries<SalesData, num>(
  ///                  selectionSettings: SelectionSettings(
  ///                    selectedColor: Colors.red.withOpacity(0.8),
  ///                    selectedBorderWidth: 2
  ///                  ),
  ///                ),
  ///              ],
  ///        ));
  ///}
  ///```
  final double selectedBorderWidth;
  ///```dart
  ///Widget build(BuildContext context) {
  ///    return Container(
  ///        child: SfCartesianChart(
  ///            series: <BarSeries<SalesData, num>>[
  ///                BarSeries<SalesData, num>(
  ///                  selectionSettings: SelectionSettings(
  ///                    unselectedColor: Colors.grey.withOpacity(0.5)
  ///                  ),
  ///                ),
  ///              ],
  ///        ));
  ///}
  ///```
  final Color unselectedColor;
  ///```dart
  ///Widget build(BuildContext context) {
  ///    return Container(
  ///        child: SfCartesianChart(
  ///            series: <BarSeries<SalesData, num>>[
  ///                BarSeries<SalesData, num>(
  ///                  selectionSettings: SelectionSettings(
  ///                    unselectedBorderColor: Colors.grey.withOpacity(0.5)
  ///                  ),
  ///                ),
  ///              ],
  ///        ));
  ///}
  ///```
  final Color unselectedBorderColor;
  ///```dart
  ///Widget build(BuildContext context) {
  ///    return Container(
  ///        child: SfCartesianChart(
  ///            series: <BarSeries<SalesData, num>>[
  ///                BarSeries<SalesData, num>(
  ///                  selectionSettings: SelectionSettings(
  ///                    unselectedBorderWidth: 2
  ///                  ),
  ///                ),
  ///              ],
  ///        ));
  ///}
  ///```
  final double unselectedBorderWidth;
   ///```dart
  ///Widget build(BuildContext context) {
  ///    return Container(
  ///        child: SfCartesianChart(
  ///            series: <BarSeries<SalesData, num>>[
  ///                BarSeries<SalesData, num>(
  ///                  selectionSettings: SelectionSettings(
  ///                    selectedOpacity: 1.0,
  ///                  ),
  ///                ),
  ///              ],
  ///        ));
  ///}
  ///```
  final double selectedOpacity;
     ///```dart
  ///Widget build(BuildContext context) {
  ///    return Container(
  ///        child: SfCartesianChart(
  ///            series: <BarSeries<SalesData, num>>[
  ///                BarSeries<SalesData, num>(
  ///                  selectionSettings: SelectionSettings(
  ///                    unselectedOpacity: 0.5,
  ///                  ),
  ///                ),
  ///              ],
  ///        ));
  ///}
  ///``
  final double unselectedOpacity;
 
  _SelectionRenderer _selectionRenderer;

  void selectionIndex(int pointIndex, int seriesIndex,
      [SelectionType selectionType, bool multiSelect]) {
    _selectionRenderer?.selectionIndex(
        pointIndex, seriesIndex, selectionType, multiSelect);
  }

  void _selectedDataPointIndex(List<IndexesModel> selectedData) {
    _selectionRenderer?.selectedDataPointIndex(selectedData);
  }

  @override
  Paint getSelectedItemFill(Paint paint, int seriesIndex, int pointIndex,
      List<ChartSegment> selectedSegments) {
    return paint;
  }

  @override
  Paint getUnselectedItemFill(Paint paint, int seriesIndex, int pointIndex,
      List<ChartSegment> unselectedSegments) {
    return paint;
  }

  @override
  Paint getSelectedItemBorder(Paint paint, int seriesIndex, int pointIndex,
      List<ChartSegment> selectedSegments) {
    return paint;
  }

  @override
  Paint getUnselectedItemBorder(Paint paint, int seriesIndex, int pointIndex,
      List<ChartSegment> unselectedSegments) {
    return paint;
  }

  @override
  Color getCircularSelectedItemFill(Color color, int seriesIndex,
      int pointIndex, List<_Region> selectedRegions) {
    return color;
  }
  
  @override
  Color getCircularUnSelectedItemFill(Color color, int seriesIndex,
      int pointIndex, List<_Region> unselectedRegions) {
    return color;
  }

  @override
  Color getCircularSelectedItemBorder(Color color, int seriesIndex,
      int pointIndex, List<_Region> selectedRegions) {
    return color;
  }

  @override
  Color getCircularUnSelectedItemBorder(Color color, int seriesIndex,
      int pointIndex, List<_Region> unselectedRegions) {
    return color;
  }

  @override
  void onDoubleTap(double xPos, double yPos) {
    _selectionRenderer.performSelection(Offset(xPos, yPos));
  }

  @override
  void onLongPress(double xPos, double yPos) {
    _selectionRenderer.performSelection(Offset(xPos, yPos));
  }

  @override
  void onTouchDown(double xPos, double yPos) {
    _selectionRenderer.performSelection(Offset(xPos, yPos));
  }

  @override
  void onCircularTouchDown(int pointIndex, int seriesIndex) {
    _selectionRenderer.performCircularSelection(pointIndex, seriesIndex);
  }

  @override
  void onCircularDoubleTap(int pointIndex, int seriesIndex) {
    _selectionRenderer.performCircularSelection(pointIndex, seriesIndex);
  }

  @override
  void onCircularLongPress(int pointIndex, int seriesIndex) {
    _selectionRenderer.performCircularSelection(pointIndex, seriesIndex);
  }
}